var tests = require('dynamicsmodule');
var dodge = require('dodgeball');
var msg = require('message');

function isiOS7Plus()
{
    // add iphone specific tests
    if (Titanium.Platform.name == 'iPhone OS')
    {
        var version = Titanium.Platform.version.split(".");
        var major = parseInt(version[0],10);
         
        // can only test this support on a 3.2+ device
        if (major >= 7)
        {
            return true;
        }
    }
    return false;
 
};

var win = Ti.UI.createWindow({
    backgroundColor: 'white',
    title:'DYNAMICS',
});

var listView = Ti.UI.createListView();

var dynamics = Ti.UI.createListSection({ headerTitle: 'Dynamics Examples'});

if (isiOS7Plus()) {
	var data = [
	    {properties: { title: 'Snap'}},
	    {properties: { title: 'Forces'}},
	    {properties: { title: 'Attachment'}},
	    {properties: { title: 'Dodge'}},
	    {properties: { title: 'Messages'}},
	];
	dynamics.setItems(data);
	listView.sections = [dynamics];
	
	win.add(listView);	
}
else {
	var label = Ti.UI.createLabel({
		color: 'black',
		text: 'Dynamics is only suppported on iOS 7 and above'
	});
	
	win.add(label);
}


var nav = Ti.UI.iOS.createNavigationWindow({
    window:win,
    orientationModes:[Ti.UI.PORTRAIT]
});

nav.open();

listView.addEventListener('itemclick',function(e){
    switch(e.itemIndex){
        case 0: tests.snapTest(nav);break;
        case 1: tests.forceTest(nav);break;
        case 2: tests.anchorTest(nav);break;
        case 3: dodge.dodgeGame(nav);break;
        case 4: msg.messageDemo(nav); break;
    }
});