function buildKillObject()
{
	p = Math.floor(Math.random()*100)+'%';
	var kView = Ti.UI.createView({
	    width:10,
	    height:10,
	    backgroundColor:'red',
	    center:{x:p,y:p},
	    opacity:0.2,
	    touchEnabled:false,
	    lives:20
	});

	return kView;
}

function randomAngle()
{
	var ZERO2TWOPI = (Math.random()*Math.PI*2);
	return ZERO2TWOPI - Math.PI;
}

function updateKillObject(object,animator,collision,win,checkLives) {
	var lives = object.lives;
	if (lives > 1 || checkLives == false) {
		object.gravity.angle = randomAngle();
		if (checkLives == true) {
			object.lives = lives - 1;
			object.opacity = (lives - 1)/20;
		}
	} else {
		collision.removeItem(object);
		animator.removeBehavior(object.gravity);
		win.remove(object);
	}
}


function configureKillObject(lastView,collision,animator)
{
	var puchC = Ti.UI.iOS.createPushBehavior({angle:randomAngle(),magnitude:0.01,pushMode:Ti.UI.iOS.PUSH_MODE_CONTINUOUS});
	lastView.opacity = 1;
	lastView.gravity = puchC;
	puchC.addItem(lastView);
	collision.addItem(lastView);
	animator.addBehavior(puchC);
}

function buildDodge(navWindow)
{
	var win = Ti.UI.createWindow({
	    backgroundColor:'white',
	    title:'DODGE'
	});


	var saveThis = Ti.UI.createView({
	    width:20,
	    height:20,
	    backgroundColor:'green',
	    center:{x:'50%',y:'50%'},
	    touchEnabled:false,
	    zIndex:5,
	    lives:10
	});

	win.add(saveThis);

	var dynamic = Ti.UI.iOS.createDynamicItemBehavior({resistance:0.5});
	dynamic.addItem(saveThis);

	var collision = Ti.UI.iOS.createCollisionBehavior({treatReferenceAsBoundary:true});
	collision.addItem(saveThis);

	var animator = Ti.UI.iOS.createAnimator({
	    referenceView:win,
	    behaviors:[dynamic,collision]
	});

	var lastView = null;
	var genTimer = setInterval(function(){
		if (lastView == null) {
			lastView = buildKillObject();
			win.add(lastView);
		} else {
			configureKillObject(lastView,collision,animator);
			lastView = null;
		}
    }, 1000);

	collision.addEventListener('boundarycollision',function(e){
		if(e.start == true) {
			if (e.item == saveThis) {
				var lives = saveThis.lives;
				if (lives > 1) {
					saveThis.lives = lives - 1;
					if (lives == 6) {
						saveThis.opacity = 0.5;
					}
				} else {
					animator.removeAllBehaviors();
					clearInterval(genTimer);
					alert('DEAD');
				}
			} else {
				updateKillObject(e.item,animator,collision,win,false);
			}
		} 
	});

	collision.addEventListener('itemcollision',function(e){
		if(e.start == true) {
			if (e.item1 == saveThis) {
				animator.removeAllBehaviors();
				clearInterval(genTimer);
				alert('DEAD');
			} else {
				updateKillObject(e.item1,animator,collision,win,true);
			}
			if (e.item2 == saveThis) {
				animator.removeAllBehaviors();
				clearInterval(genTimer);
				alert('DEAD');
			} else {
				updateKillObject(e.item2,animator,collision,win);
			}
		} 
	});

	var startPoint = null;
	

	function updateSaveItem(e){
		var diff = {x:e.x - startPoint.x,y:e.y - startPoint.y};
		startPoint = {x:e.x,y:e.y};
		dynamic.addLinearVelocityForItem(saveThis,diff);
	}

	win.addEventListener('touchstart',function(e){
		startPoint = {x:e.x,y:e.y};
	});
	win.addEventListener('touchmove',function(e){
		updateSaveItem(e);
	});
	win.addEventListener('touchend',function(e){
		updateSaveItem(e);
	});
	win.addEventListener('touchcancel',function(e){
		updateSaveItem(e);
	});

	win.addEventListener('blur',function(){
		//In a nav Window this event occurs before the view detaches so this is a 
		//good place to remove behaviors which also stops animator
		animator.removeAllBehaviors();
	});

	win.addEventListener('focus',function(){
		animator.startAnimator();
	});

	navWindow.openWindow(win);


}

module.exports = {
	dodgeGame:buildDodge
};